Imports PCBI.Automation
Imports PCBI___IDF_Import
Imports PCBI_IPC2581
Imports PCBIGenCadFilter
Imports System
Imports System.ComponentModel
Imports System.Drawing
Imports System.IO
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Namespace HowToUseImportPlugIns
	Public Class FormexampleImports
		Inherits Form

		Private components As IContainer = Nothing

        Private WithEvents buttonGenCad As Button

        Private WithEvents buttonIPC As Button

        Private WithEvents buttonIDF As Button

		Friend WorkingDirectory As String = Path.GetTempPath() + "tests" + Path.DirectorySeparatorChar

        Protected Sub Dispose(ByVal disposing As Boolean)
            If disposing AndAlso Me.components IsNot Nothing Then
                Me.components.Dispose()
            End If
            MyBase.Dispose(disposing)
        End Sub

        Private Sub InitializeComponent()
            Me.buttonGenCad = New Button()
            Me.buttonIPC = New Button()
            Me.buttonIDF = New Button()
            MyBase.SuspendLayout()
            Me.buttonGenCad.Location = New Point(12, 12)
            Me.buttonGenCad.Name = "buttonGenCad"
            Me.buttonGenCad.Size = New Size(260, 81)
            Me.buttonGenCad.TabIndex = 0
            Me.buttonGenCad.Text = "Load GenCad"
            Me.buttonGenCad.UseVisualStyleBackColor = True
            Me.buttonIPC.Location = New Point(12, 99)
            Me.buttonIPC.Name = "buttonIPC"
            Me.buttonIPC.Size = New Size(260, 81)
            Me.buttonIPC.TabIndex = 1
            Me.buttonIPC.Text = "Load IPC2581"
            Me.buttonIPC.UseVisualStyleBackColor = True
            Me.buttonIDF.Location = New Point(12, 187)
            Me.buttonIDF.Name = "buttonIDF"
            Me.buttonIDF.Size = New Size(260, 81)
            Me.buttonIDF.TabIndex = 2
            Me.buttonIDF.Text = "Load IDF"
            Me.buttonIDF.UseVisualStyleBackColor = True
            MyBase.AutoScaleDimensions = New SizeF(6.0F, 13.0F)
            MyBase.AutoScaleMode = AutoScaleMode.Font
            MyBase.ClientSize = New Size(284, 280)
            MyBase.Controls.Add(Me.buttonIDF)
            MyBase.Controls.Add(Me.buttonIPC)
            MyBase.Controls.Add(Me.buttonGenCad)
            MyBase.Name = "FormexampleImports"
            Me.Text = "Example Imports"
            MyBase.ResumeLayout(False)
        End Sub

        Public Sub New()
            Me.InitializeComponent()
            IAutomation.IAutomationInit()
        End Sub

        Private Sub buttonGenCad_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonGenCad.Click
            Dim openGenCad As OpenFileDialog = New OpenFileDialog()
            openGenCad.Title = "Select GenCad 1.4 File"
            If openGenCad.ShowDialog() = DialogResult.OK Then
                Dim parentPCBI As IPCBIWindow = IAutomation.CreateNewPCBIWindow(True)
                Dim gencadFilter As IPNLFilter = New IPNLFilter(parentPCBI)
                gencadFilter.LoadGenCadFile(openGenCad.FileName, Me.WorkingDirectory + "GenCadData")
            End If
        End Sub

        Private Sub buttonIPC_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonIPC.Click
            Dim openIPC As OpenFileDialog = New OpenFileDialog()
            openIPC.Title = "Select IPC2581 File"
            If openIPC.ShowDialog() = DialogResult.OK Then
                Dim parentPCBI As IPCBIWindow = IAutomation.CreateNewPCBIWindow(True)
                Dim ipcFilter As IFilterIPC2581 = New IFilterIPC2581(parentPCBI)
                If Not ipcFilter.Load(openIPC.FileName, Me.WorkingDirectory + "IPCData", False) Then
                    Console.WriteLine("Can't load file...")
                End If
            End If
        End Sub

        Private Sub buttonIDF_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonIDF.Click
            Dim openIDF As OpenFileDialog = New OpenFileDialog()
            openIDF.Title = "Select IDB file and IDL-file"
            openIDF.Multiselect = True
            If openIDF.ShowDialog() = DialogResult.OK Then
                If openIDF.FileNames.Length > 1 Then
                    Me.LoadIDF(openIDF.FileNames(0), openIDF.FileNames(1))
                Else
                    Me.LoadIDF(openIDF.FileName, openIDF.FileName.Replace(".idb", ".idl"))
                End If
            End If
        End Sub

        Friend Sub LoadIDF(ByVal fullPathIDB As String, ByVal fullPathIDL As String)
            Dim parentPCBI As IPCBIWindow = IAutomation.CreateNewPCBIWindow(True)
            Dim filter As IFilterIDF = New IFilterIDF()
            Try
                Dim errors As StringBuilder = New StringBuilder()
                If Not filter.ImportIDF(parentPCBI, Me.WorkingDirectory + "IDFData", fullPathIDB, fullPathIDL, errors) Then
                    Console.WriteLine(errors.ToString())
                End If
            Catch ex As Exception
                Console.WriteLine("Can't open IDF Data, because " + ex.ToString())
            End Try
        End Sub
    End Class
End Namespace
